com.orsoncharts

## Class ChartBox3D

- java.lang.Object
- - com.orsoncharts.ChartBox3D

-     public class ChartBox3D
      extends java.lang.Object

  A chart box is the container within which the chart elements are drawn. The six faces of the box created so that they are visible only when they do not obscure the content of the chart (generally the back three faces will be visible and the front three faces will not be visible, although from some angles four faces will be visible at one time). There is also support provided for specifying gridlines on the visible faces, as well as markers to label specific values and value ranges.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ChartBox3D.ChartBoxFace` A special subclass of `Face` that is used by the `ChartBox3D` so that when faces are sorted by z-order, the chart box sides are always drawn first (furthest in the background).

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ChartBox3D(double xLength, double yLength, double zLength, double xOffset, double yOffset, double zOffset, java.awt.Color color)` Creates a new chart box with the specified attributes.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Object3D` | `createObject3D()` Creates an `Object3D` that contains the six faces for the chart box, plus the vertices for the tick marks along the edges of each face.
    `ChartBox3D.ChartBoxFace` | `faceA()` Returns face A (the bottom face, in the XZ axis plane).
    `ChartBox3D.ChartBoxFace` | `faceB()` Returns face B (the front face, in the XY axis plane).
    `ChartBox3D.ChartBoxFace` | `faceC()` Returns face C (the top face, in the XZ axis plane).
    `ChartBox3D.ChartBoxFace` | `faceD()` Returns face D (the rear face, in the XY axis plane).
    `ChartBox3D.ChartBoxFace` | `faceE()` Returns face E (the left face, in the YZ axis plane).
    `ChartBox3D.ChartBoxFace` | `faceF()` Returns face F (the right face, in the YZ axis plane).
    `java.util.List<MarkerData>` | `getXMarkers()` Returns the marker data for the x-axis markers, if any.
    `java.util.List<TickData>` | `getXTicks()` Returns the list of tick data items for the x-axis.
    `java.util.List<MarkerData>` | `getYMarkers()` Returns the marker data for the y-axis markers, if any.
    `java.util.List<TickData>` | `getYTicks()` Returns the list of tick data items for the y-axis.
    `java.util.List<MarkerData>` | `getZMarkers()` Returns the marker data for the z-axis markers, if any.
    `java.util.List<TickData>` | `getZTicks()` Returns the list of tick data items for the z-axis.
    `void` | `setXMarkers(java.util.List<MarkerData> markers)` Sets the list of marker data items for the x-axis.
    `void` | `setXTicks(java.util.List<TickData> ticks)` Sets the list of tick data items for the x-axis.
    `void` | `setYMarkers(java.util.List<MarkerData> markers)` Sets the list of marker data items for the y-axis.
    `void` | `setYTicks(java.util.List<TickData> ticks)` Sets the list of tick data items for the y-axis.
    `void` | `setZMarkers(java.util.List<MarkerData> markers)` Sets the list of marker data items for the x-axis.
    `void` | `setZTicks(java.util.List<TickData> ticks)` Sets the list of tick data items for the z-axis.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ChartBox3D

          public ChartBox3D(double xLength,
                            double yLength,
                            double zLength,
                            double xOffset,
                            double yOffset,
                            double zOffset,
                            java.awt.Color color)

      Creates a new chart box with the specified attributes. When drawn, only the faces at the rear of the box will be rendered, allowing the user to see the content of the box (typically the plot items).
      Parameters:
        `xLength` - the x-dimension.
        `yLength` - the y-dimension.
        `zLength` - the z-dimension.
        `xOffset` - the x-offset.
        `yOffset` - the y-offset.
        `zOffset` - the z-offset.
        `color` - the color for the sides of the box (`null` not permitted).

  - ### Method Detail

    - #### getXTicks

          public java.util.List<TickData> getXTicks()

      Returns the list of tick data items for the x-axis.
      Returns:
        The list of tick data items for the x-axis (possibly empty, but never `null`).
      Since:
        1.2

    - #### setXTicks

          public void setXTicks(java.util.List<TickData> ticks)

      Sets the list of tick data items for the x-axis.
      Parameters:
        `ticks` - the tick data (`null` not permitted).
      Since:
        1.2

    - #### getYTicks

          public java.util.List<TickData> getYTicks()

      Returns the list of tick data items for the y-axis.
      Returns:
        The list of tick data items for the y-axis (possibly empty, but never `null`).
      Since:
        1.2

    - #### setYTicks

          public void setYTicks(java.util.List<TickData> ticks)

      Sets the list of tick data items for the y-axis.
      Parameters:
        `ticks` - the tick data (`null` not permitted).
      Since:
        1.2

    - #### getZTicks

          public java.util.List<TickData> getZTicks()

      Returns the list of tick data items for the z-axis.
      Returns:
        The list of tick data items for the z-axis (possibly empty, but never `null`).
      Since:
        1.2

    - #### setZTicks

          public void setZTicks(java.util.List<TickData> ticks)

      Sets the list of tick data items for the z-axis.
      Parameters:
        `ticks` - the tick data (`null` not permitted).
      Since:
        1.2

    - #### getXMarkers

          public java.util.List<MarkerData> getXMarkers()

      Returns the marker data for the x-axis markers, if any.
      Returns:
        The marker data for the x-axis markers (possibly empty but never `null`).
      Since:
        1.2

    - #### setXMarkers

          public void setXMarkers(java.util.List<MarkerData> markers)

      Sets the list of marker data items for the x-axis.
      Parameters:
        `markers` - the list of marker data items (`null` not permitted).
      Since:
        1.2

    - #### getYMarkers

          public java.util.List<MarkerData> getYMarkers()

      Returns the marker data for the y-axis markers, if any.
      Returns:
        The marker data for the y-axis markers (possibly empty but never `null`).
      Since:
        1.2

    - #### setYMarkers

          public void setYMarkers(java.util.List<MarkerData> markers)

      Sets the list of marker data items for the y-axis.
      Parameters:
        `markers` - the list of marker data items (`null` not permitted).
      Since:
        1.2

    - #### getZMarkers

          public java.util.List<MarkerData> getZMarkers()

      Returns the marker data for the z-axis markers, if any.
      Returns:
        The marker data for the z-axis markers (possibly empty but never `null`).
      Since:
        1.2

    - #### setZMarkers

          public void setZMarkers(java.util.List<MarkerData> markers)

      Sets the list of marker data items for the x-axis.
      Parameters:
        `markers` - the list of marker data items (`null` not permitted).
      Since:
        1.2

    - #### faceA

          public ChartBox3D.ChartBoxFace faceA()

      Returns face A (the bottom face, in the XZ axis plane).
      Returns:
        Face A.

    - #### faceB

          public ChartBox3D.ChartBoxFace faceB()

      Returns face B (the front face, in the XY axis plane).
      Returns:
        Face B.

    - #### faceC

          public ChartBox3D.ChartBoxFace faceC()

      Returns face C (the top face, in the XZ axis plane).
      Returns:
        Face C.

    - #### faceD

          public ChartBox3D.ChartBoxFace faceD()

      Returns face D (the rear face, in the XY axis plane).
      Returns:
        Face D.

    - #### faceE

          public ChartBox3D.ChartBoxFace faceE()

      Returns face E (the left face, in the YZ axis plane).
      Returns:
        Face E.

    - #### faceF

          public ChartBox3D.ChartBoxFace faceF()

      Returns face F (the right face, in the YZ axis plane).
      Returns:
        Face F.

    - #### createObject3D

          public Object3D createObject3D()

      Creates an `Object3D` that contains the six faces for the chart box, plus the vertices for the tick marks along the edges of each face.
      Returns:
        A 3D object.